--list.hs
--     
--    <xstazz@hotbox.ru>
--  http://vt.spbgmtu.ru


-- 
length1 [] = 0
length1 (x:xs) = 1 + length1 (xs)

-- 
append1 [] ys = ys
append1 (x:xs) ys = x: append1 xs ys

-- 
head1 (x:xs) = x
head1 [] = error "List is empty"

-- 
tail1 (x:xs) = xs
tail1 [] = error "List is empty"

--  
last1 [x] = x
last1 [] = error "List is empty"
last1 (x:xs) = last xs

-- 
rev1 [] = []
rev1 (x:xs) = rev1(xs)++[x]

-- 
copy1 [] = []
copy1 (x:xs) = x: copy1 xs 

--    
insert1 n [] = [n]
insert1 n (x:xs) = if n<x then n:x:xs
                          	 else x: insert1 n xs

-- 
append_sort1 [] xs = xs
append_sort1 (x:xs) ys = insert1 x (append_sort1 xs ys)

-- 
tail_copy1 [] = error "List is empty"
tail_copy1 (x:xs) = copy1 xs

-- 
qsort1 [] = []
qsort1 (x:xs) = qsort1 [y | y<-xs, y<x] ++ [x] ++ qsort1 [y | y<-xs, y>=x]

--  ,  
filter1 p [] = []
filter1 p (x:xs) = if p x then x: (filter1 p xs)
			         else filter1 p xs

--     
map1 f [] = []
map1 f (x:xs) = f x: map f (xs)

--   
all1 :: (a -> Bool) -> [a] -> Bool
all1 p = and. map1 p

--     
any1 :: (a -> Bool) -> [a] -> Bool
any1 p = or. map1 p

--    
zipWith1 z [] [] = []
zipWith1 z (a:as) (b:bs) = z a b : zipWith1 z as bs

--    ,     
zip1 = zipWith1 (,)

rev2 :: [a] -> [a] -> [a]
rev2 [] ys = ys
rev2 (x:xs) ys = rev2 xs (x:ys)

--   
elem1 n [] = error "elem: index<1"
elem1 n (x:xs)	| n<1 = error "elem: index<1"
		| n==1 = x
		| n>1 = elem1 (n-1) xs

--   
take1 n [] = error "elem: index<1"
take1 n (x:xs)	| n<1 = []
		| n>=1 = x: (take1 (n-1) xs)

--    
foldr2 :: (a -> b -> b) -> b -> [a] -> b
foldr2 f z [] = z
foldr2 f z (x:xs) = f x (foldr2 f z xs)

--    
foldl2 :: (a -> b -> a) -> a -> [b] -> a
foldl2 f z [] = z
foldl2 f z (x:xs) = foldl2 f (f z x) xs

--     foldr  foldl
copy2 = foldr2 (:) []

append2 xs ys = foldr2 (:) ys xs

rev3 = foldl2 (flip (:)) []

length2 s = foldr2 (+) 0 (map1 (\x -> 1) s)

append_sort2 xs ys = foldr (insert1) ys xs  

filter2 p = foldr2 (\x xs -> if (p x) then x:xs else xs) []

map2 f s = foldr (\x y -> (f x):y) [] s

all2 p s = foldr2 (\x y -> (p x) && y) True s

any2 p s = foldr2 (\x y -> (p x) || y) False s